package plsqleditor.actions;

import java.util.ResourceBundle;

import org.eclipse.jface.text.IDocument;
import org.eclipse.jface.text.ITextSelection;
import org.eclipse.ui.IFileEditorInput;
import org.eclipse.ui.texteditor.ITextEditor;
import org.eclipse.ui.texteditor.TextEditorAction;

/**
 * This class
 * 
 * @author Toby Zines
 * 
 * @version $Id: SelectedTextAction.java,v 1.2 2005/03/29 06:05:22 tobyz Exp $
 * 
 * Created on 15/03/2005
 * 
 */
public class SelectedTextAction extends TextEditorAction
{
    public SelectedTextAction(ResourceBundle bundle, String prefix, ITextEditor editor)
    {
        super(bundle, prefix, editor);
    }

    public void run()
    {
        ITextEditor editor = getTextEditor();
        IFileEditorInput input = (IFileEditorInput) editor.getEditorInput();
        ITextSelection selection = (ITextSelection) editor.getSelectionProvider().getSelection();
        IDocument doc = editor.getDocumentProvider().getDocument(input);
        operateOn(doc, selection);
    }

    protected void operateOn(IDocument doc, ITextSelection selection)
    {
        // by default do nothing
    }

}
